Index: /code/trunk/src/modules/notifications/NotificationQueue.h
===================================================================
--- /code/trunk/src/modules/notifications/NotificationQueue.h	(revision 7402)
+++ /code/trunk/src/modules/notifications/NotificationQueue.h	(revision 7403)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file NotificationQueue.h
     @brief Definition of the NotificationQueue class.
 */
@@ -38,28 +38,26 @@
 
 #include <ctime>
-#include <map>
 #include <set>
 #include <string>
+#include <vector>
 
-#include "util/Math.h"
 #include "tools/interfaces/Tickable.h"
-#include "overlays/OverlayGroup.h"
+
 #include "interfaces/NotificationListener.h"
+#include "NotificationManager.h"
 
-namespace orxonox
-{
+namespace orxonox // tolua_export
+{ // tolua_export
 
     //! Container to allow easy handling.
-    struct NotificationOverlayContainer
+    struct NotificationContainer
     {
-        NotificationOverlay* overlay; //!< Pointer to the NotificationOverlay, everything is about.
-        Notification* notification; //!< The Notification displayed by the overlay.
+        Notification* notification; //!< The Notification displayed.
         time_t time; //!< The time the Notification was sent and thus first displayed.
-        std::string name; //!< The name of the overlay.
     };
 
-    //! Struct to allow ordering of NotificationOverlayContainers.
-    struct NotificationOverlayContainerCompare {
-        bool operator() (const NotificationOverlayContainer* const & a, const NotificationOverlayContainer* const & b) const
+    //! Struct to allow ordering of NotificationContainers.
+    struct NotificationContainerCompare {
+        bool operator() (const NotificationContainer* const & a, const NotificationContainer* const & b) const
             { return a->time < b->time; } //!< Ordered by time.
     };
@@ -68,149 +66,103 @@
     @brief
         Displays Notifications from specific senders.
-        Beware! The NotificationQueue is an OverlayGruop and thus cannot be be a sub-element of an OverlayGroup (at least no for now.)
-
-        Creating a NotificationQueue through XML goes as follows:
-        Be aware that the NotificationQueue must be inside the @code <Level></Level> @endcode tags or bad things will happen.
-        
-        @code
-        <NotificationQueue
-            name = "SuperQueue" //Name of your OverlayQueue.
-            maxSize = "5" //The maximum number of Notifications displayed. (Default is 5)
-            notificationLength = "64" //The maximum number of characters of a Notification, that are displayed. (Default is 64)
-            displayTime = "30" //The time a Notification is displayed in seconds. (Default is 30)
-            targets = "target1, target2" //The senders this NotificationQueue displays Notifications from. (all, if all Notifications should be displayed.)
-            font = "VeraMono" //The font (Default is VeraMono)
-            fontSize = '0.4' //The font size. (Default is 0.025)
-            position = "0.0, 0.0" //The position of the NotificationQueue. (Default is 0.0,0.0)
-        />
-        @endcode
     @author
         Damian 'Mozork' Frick
     */
-
-    class _NotificationsExport NotificationQueue : public OverlayGroup, public Tickable, public NotificationListener
-    {
+    class _NotificationsExport NotificationQueue // tolua_export
+        : public Tickable, public NotificationListener
+    { // tolua_export
 
         public:
-            NotificationQueue(BaseObject* creator);
+            NotificationQueue(const std::string& name, const std::string& senders = NotificationManager::ALL, unsigned int size = NotificationQueue::DEFAULT_SIZE, unsigned int displayTime = NotificationQueue::DEFAULT_DISPLAY_TIME);
             virtual ~NotificationQueue();
 
-            virtual void XMLPort(Element& xmlelement, XMLPort::Mode mode); //!< Method for creating a NotificationQueue object through XML.
+            /**
+            @brief Destroys the NotificationQueue.
+                   Used in lua.
+            */
+            void destroy(void) { this->OrxonoxClass::destroy(); } // tolua_export
 
             virtual void tick(float dt); //!< To update from time to time.
 
-            void update(void); //!< Updates the queue.
-            void update(Notification* notification, const std::time_t & time); //!< Adds a Notification to the queue.
+            void update(void); //!< Updates the NotificationQueue.
+            void update(Notification* notification, const std::time_t & time); //!< Updates the NotificationQueue by adding an new Notification.
 
+            // tolua_begin
+            /**
+            @brief Get the name of the NotificationQueue.
+            @return Returns the name.
+            */
+            inline const std::string& getName() const
+                { return this->name_; }
+
+            void setMaxSize(unsigned int size); //!< Sets the maximum number of displayed Notifications.
             /**
             @brief Returns the maximum number of Notifications displayed.
             @return Returns maximum size.
             */
-            inline int getMaxSize() const
+            inline unsigned int getMaxSize() const
                 { return this->maxSize_; }
-            /**
-            @brief Returns the current number of Notifications displayed.
-            @return Returns the size of the queue.
-            */
-            inline int getSize() const
-                { return this->size_; }
-            /**
-            @brief Returns the maximum length in characters a Notification message is allowed to have.
-            @return Returns the maximum Notification length.
-            */
-            inline int getNotificationLength() const
-                { return this->notificationLength_; }
+
+            void setDisplayTime(unsigned int time); //!< Sets the maximum number of seconds a Notification is displayed.
             /**
             @brief Returns the time interval the Notification is displayed.
             @return Returns the display time.
             */
-            inline int getDisplayTime() const
+            inline float getDisplayTime() const
                 { return this->displayTime_; }
-            /**
-            @brief Returns the position of the NotificationQueue.
-            @return Returns the position.
-            */
-            inline const Vector2 & getPosition() const
-                { return this->position_; }
-            /**
-            @brief Returns the font size used to display the Notifications.
-            @return  Returns the font size.
-            */
-            inline float getFontSize() const
-                { return this->fontSize_; }
-            /**
-            @brief Returns the font used to display the Notifications.
-            @return Returns the font.
-            */
-            inline const std::string & getFont() const
-                { return this->font_; }
+            // tolua_end
 
             /**
-            @brief Returns the targets of this queue, reps. the senders which Notifications are displayed in this queue.
-            @return Retuns a set of string holding the different targets.
+            @brief Returns the current number of Notifications displayed.
+            @return Returns the size of the NotificationQueue.
             */
-            inline const std::set<std::string> & getTargetsSet()
-                { return this->targets_; }
-            bool getTargets(std::string* string) const; //!< Returns a string consisting of the concatination of the targets.
+            inline unsigned int getSize() const
+                { return this->size_; }
 
             /**
-            @brief Sets the position of the NotificationQueue.
-            @param pos The position.
+            @brief Returns the targets of this NotificationQueue, reps. the senders which Notifications are displayed in this NotificationQueue.
+            @return Returns a set of strings holding the different targets.
             */
-            inline void setPosition(Vector2 pos)
-                { this->position_ = pos; this->positionChanged(); }
+            inline const std::set<std::string, NotificationListenerStringCompare> & getTargetsSet()
+                { return this->targets_; }
 
-            void scroll(const Vector2 pos); //!< Scrolls the NotificationQueue, meaning all NotificationOverlays are moved the input vector.
+            // tolua_begin
+            void setTargets(const std::string & targets); //!< Set the targets of this NotificationQueue.
+            const std::string& getTargets(void) const; //!< Returns a string consisting of the concatination of the targets.
+            // tolua_end
 
         private:
-            static const int DEFAULT_SIZE = 5; //!< The default maximum number of Notifications displayed.
-            static const int DEFAULT_LENGTH = 64; //!< The default maximum number of characters displayed.
-            static const int DEFAULT_DISPLAY_TIME = 30; //!< The default display time.
-            static const float DEFAULT_FONT_SIZE; //!< The default font size.
+            static const unsigned int DEFAULT_SIZE = 5; //!< The default maximum number of Notifications displayed.
+            static const unsigned int DEFAULT_DISPLAY_TIME = 30; //!< The default display time.
 
-            static const std::string DEFAULT_FONT; //!< The default font.
-            static const Vector2 DEFAULT_POSITION; //!< the default position.
+            std::string name_; //!< The name of the NotificationQueue.
 
-            int maxSize_; //!< The maximal number of Notifications displayed.
-            int size_; //!< The number of Notifications displayed.
-            int notificationLength_; //!< The maximal number of characters a Notification-message is allowed to have.
-            int displayTime_; //!< The time a Notification is displayed.
-            Vector2 position_; //!< The position of the NotificationQueue.
-
-            std::set<std::string> targets_; //!< The targets the Queue displays Notifications of.
-
-            float fontSize_; //!< The font size.
-            std::string font_; //!< The font.
-
-            std::multiset<NotificationOverlayContainer*, NotificationOverlayContainerCompare> containers_; //!< Multiset, because the ordering is based on, not necessarily unique, timestamps.
-            std::map<Notification*, NotificationOverlayContainer*> overlays_; //!< Mapping notifications to their corresponding overlay containers, for easier association and finding.
-
-            float tickTime_; //!< Helper variable, to not have to check for overlays that have been displayed too long, every tick.
-            NotificationOverlayContainer timeLimit_; //!< Helper object to check against to determine whether Notifications have expired.
+            unsigned int maxSize_; //!< The maximal number of Notifications displayed.
+            unsigned int size_; //!< The number of Notifications displayed.
+            unsigned int displayTime_; //!< The time a Notification is displayed.
 
             bool registered_; //!< Helper variable to remember whether the NotificationQueue is registered already.
 
-            void initialize(void); //!< Initializes the object.
-            void setDefaults(void); //!< Helper method to set the default values.
+            std::set<std::string, NotificationListenerStringCompare> targets_; //!< The targets the NotificationQueue displays Notifications of.
 
-            bool setMaxSize(int size); //!< Sets the maximum number of displayed Notifications.
-            bool setNotificationLength(int length); //!< Sets the maximum number of characters a Notification message displayed by this queue is allowed to have.
-            bool setDisplayTime(int time); //!< Sets the maximum number of seconds a Notification is displayed.
+            std::multiset<NotificationContainer*, NotificationContainerCompare> ordering_; //!< The NotificationContainers ordered by the time they were registered.
+            std::vector<NotificationContainer*> notifications_; //!< The NotificationContainers in the order they were added to the NotificationQueue.
 
-            bool setTargets(const std::string & targets); //!< Set the targets of this queue.
+            float tickTime_; //!< Helper variable, to not have to check for Notifications that have been displayed too long, every tick.
+            NotificationContainer timeLimit_; //!< Helper object to check against to determine whether Notifications have expired.
 
-            bool setFontSize(float size); //!< Set the font size.
-            bool setFont(const std::string & font); //!< Set the font.
+            void create(void); //!< Creates the NotificationQueue in lua.
 
-            void positionChanged(void); //!< Aligns all the Notifications to the position of the NotificationQueue.
+            void setName(const std::string& name); //!< Sets the name of the NotificationQueue.
 
-            void addNotification(Notification* notification, const std::time_t & time); //!< Add a notification to the queue.
-            bool removeContainer(NotificationOverlayContainer* container); //!< Remove a container from the queue.
+            void push(Notification* notification, const std::time_t & time); //!< Adds (pushes) a Notification to the NotificationQueue.
+            void pop(void); //!< Removes (pops) the least recently added Notification form the NotificationQueue.
+            void remove(NotificationContainer* container); //!< Removes the Notification that is stored in the input NotificationContainer.
 
-            void clear(void); //!< Clear the queue.
+            void clear(void); //!< Clears the NotificationQueue by removing all NotificationContainers.
 
-    };
+    }; // tolua_export
 
-}
+} // tolua_export
 
 #endif /* _NotificationOverlay_H__ */
Index: /code/trunk/src/modules/notifications/NotificationsPrereqs.h
===================================================================
--- /code/trunk/src/modules/notifications/NotificationsPrereqs.h	(revision 7402)
+++ /code/trunk/src/modules/notifications/NotificationsPrereqs.h	(revision 7403)
@@ -68,5 +68,4 @@
     class NotificationDispatcher;
     class NotificationManager;
-    class NotificationOverlay;
     class NotificationQueue;
     
Index: /code/trunk/src/modules/notifications/dispatchers/CommandNotification.cc
===================================================================
--- /code/trunk/src/modules/notifications/dispatchers/CommandNotification.cc	(revision 7402)
+++ /code/trunk/src/modules/notifications/dispatchers/CommandNotification.cc	(revision 7403)
@@ -38,4 +38,5 @@
 #include "core/input/KeyBinderManager.h"
 #include "core/input/KeyBinder.h"
+#include "util/SubString.h"
 
 #include <sstream>
@@ -88,9 +89,49 @@
         std::stringstream stream;
         stream << this->getPreMessage();
-        //TODO: Add niceifyer.
-        stream << KeyBinderManager::getInstance().getCurrent()->getBinding(this->getCommand());
+        stream << this->bindingNiceifyer(KeyBinderManager::getInstance().getCurrent()->getBinding(this->getCommand()));
         stream << this->getPostMessage();
-        std::string* message = new std::string(stream.str());
-        return *message;
+        return *(new std::string(stream.str()));
+    }
+
+    /**
+    @brief
+        Transforms the input binding into a human readable form.
+    @param binding
+        The binding to be transformed
+    @return
+        Returns a human readable version of the input binding.
+    */
+    const std::string& CommandNotification::bindingNiceifyer(const std::string& binding)
+    {
+        SubString string = SubString(binding, ".");
+        std::string name;
+        std::string group;
+        switch(string.size())
+        {
+            case 0:
+                return binding;
+            case 1:
+                return binding;
+            case 2:
+                group = string[0];
+            default:
+                name = string.subSet(1, string.size()).join(".");
+        }
+
+        std::stringstream stream;
+        if(group.compare("Keys") == 0)
+            stream << "Key " << name.substr(3);
+        else if(group.compare("MouseButtons") == 0)
+            stream << "Mouse " << name;
+        else if(group.compare("JoyStickButtons") == 0)
+            stream << "Joystick " << name;
+        else if(group.compare("JoyStickAxes") == 0)
+            stream << "Joystick Axis" << name.substr(5, 6) << name.substr(name.find("Axis")+6);
+        else if(group.compare("MouseAxes") == 0)
+            stream << "Mouse " << name.substr(1,3) << " " << name.substr(0, 1) << "-Axis";
+        else
+            return binding;
+
+        return *(new std::string(stream.str()));
     }
     
Index: /code/trunk/src/modules/notifications/dispatchers/CommandNotification.h
===================================================================
--- /code/trunk/src/modules/notifications/dispatchers/CommandNotification.h	(revision 7402)
+++ /code/trunk/src/modules/notifications/dispatchers/CommandNotification.h	(revision 7403)
@@ -104,4 +104,6 @@
                  { this->postMessage_ = message; }
 
+            const std::string& bindingNiceifyer(const std::string& binding);
+
     };
 
Index: /code/trunk/src/modules/objects/triggers/MultiTriggerContainer.cc
===================================================================
--- /code/trunk/src/modules/objects/triggers/MultiTriggerContainer.cc	(revision 7402)
+++ /code/trunk/src/modules/objects/triggers/MultiTriggerContainer.cc	(revision 7403)
@@ -35,4 +35,5 @@
 
 #include "core/CoreIncludes.h"
+#include "worldentities/pawns/Pawn.h"
 
 namespace orxonox
@@ -65,4 +66,11 @@
     {
         RegisterObject(MultiTriggerContainer);
+
+        Pawn* pawn = orxonox_cast<Pawn*>(data);
+        if(pawn != NULL)
+        {
+            this->setForPlayer(true);
+            this->setTriggeringPlayer(pawn);
+        }
     }
 
Index: /code/trunk/src/modules/objects/triggers/MultiTriggerContainer.h
===================================================================
--- /code/trunk/src/modules/objects/triggers/MultiTriggerContainer.h	(revision 7402)
+++ /code/trunk/src/modules/objects/triggers/MultiTriggerContainer.h	(revision 7403)
@@ -38,4 +38,5 @@
 
 #include "core/BaseObject.h"
+#include "interfaces/PlayerTrigger.h"
 
 namespace orxonox
@@ -48,5 +49,5 @@
         Damian 'Mozork' Frick
     */
-    class _ObjectsExport MultiTriggerContainer : public BaseObject
+    class _ObjectsExport MultiTriggerContainer : public BaseObject, public PlayerTrigger
     {
 
@@ -72,4 +73,5 @@
             MultiTrigger* originator_; //!< The originator.
             BaseObject* data_; //!< The data.
+
     };
 
Index: /code/trunk/src/modules/questsystem/Quest.cc
===================================================================
--- /code/trunk/src/modules/questsystem/Quest.cc	(revision 7402)
+++ /code/trunk/src/modules/questsystem/Quest.cc	(revision 7403)
@@ -367,5 +367,5 @@
         COUT(4) << "Quest {" << this->getId() << "} is failed for player: " << player << " ." <<std::endl;
 
-        this->getDescription()->sendFailQuestNotification();
+        this->getDescription()->sendFailQuestNotification(player);
         return true;
     }
@@ -386,5 +386,5 @@
         COUT(4) << "Quest {" << this->getId() << "} is completed for player: " << player << " ." <<std::endl;
 
-        this->getDescription()->sendCompleteQuestNotification();
+        this->getDescription()->sendCompleteQuestNotification(player);
         return true;
     }
@@ -412,5 +412,5 @@
         this->setStatus(player, QuestStatus::Active);
 
-        this->getDescription()->sendAddQuestNotification();
+        this->getDescription()->sendAddQuestNotification(player);
         return true;
     }
Index: /code/trunk/src/modules/questsystem/QuestDescription.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestDescription.cc	(revision 7402)
+++ /code/trunk/src/modules/questsystem/QuestDescription.cc	(revision 7403)
@@ -84,10 +84,10 @@
     @param status
         The status the QuestDescription us for.
+    @param player
+        The player the Notification is sent to.
     @return
         Returns true if successful.
-    @todo
-        Make sure the messages meet the conditions.
     */
-    bool QuestDescription::notificationHelper(const std::string & item, const std::string & status)
+    bool QuestDescription::notificationHelper(const std::string & item, const std::string & status, PlayerInfo* player)
     {
         std::string message;
@@ -123,5 +123,5 @@
 
         QuestNotification* notification = new QuestNotification(this, message);
-        notification->send();
+        notification->send(player);
         return true;
     }
Index: /code/trunk/src/modules/questsystem/QuestDescription.h
===================================================================
--- /code/trunk/src/modules/questsystem/QuestDescription.h	(revision 7402)
+++ /code/trunk/src/modules/questsystem/QuestDescription.h	(revision 7403)
@@ -97,29 +97,33 @@
             /**
             @brief Sends a Notification displaying that a QuestHint was added.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendAddHintNotification(void)
-                { return notificationHelper("hint", ""); }
+            inline bool sendAddHintNotification(PlayerInfo* player)
+                { return notificationHelper("hint", "", player); }
 
             /**
             @brief Sends a Notification displaying that a Quest was added.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendAddQuestNotification(void)
-                { return notificationHelper("quest", "start"); }
+            inline bool sendAddQuestNotification(PlayerInfo* player)
+                { return notificationHelper("quest", "start", player); }
 
             /**
             @brief Sends a Notification displaying that a Quest was failed.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendFailQuestNotification(void)
-                { return notificationHelper("quest", "fail"); }
+            inline bool sendFailQuestNotification(PlayerInfo* player)
+                { return notificationHelper("quest", "fail", player); }
 
             /**
             @brief Sends a Notification displaying that a Quest was completed.
+            @param player The player the Notification is sent to.
             @return Returns true if successful.
             */
-            inline bool sendCompleteQuestNotification(void)
-                { return notificationHelper("quest", "complete"); }
+            inline bool sendCompleteQuestNotification(PlayerInfo* player)
+                { return notificationHelper("quest", "complete", player); }
 
         private:
@@ -129,5 +133,5 @@
             std::string completeMessage_; //!< The message displayed when the Quest is completed.
 
-            bool notificationHelper(const std::string & item, const std::string & status); //!< Helper for sending QuestDescriptions as Notifications.
+            bool notificationHelper(const std::string & item, const std::string & status, PlayerInfo* player); //!< Helper for sending QuestDescriptions as Notifications.
 
             /**
Index: /code/trunk/src/modules/questsystem/QuestHint.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestHint.cc	(revision 7402)
+++ /code/trunk/src/modules/questsystem/QuestHint.cc	(revision 7403)
@@ -121,5 +121,5 @@
                 this->playerStatus_[player] = QuestHintStatus::Active;
 
-                this->getDescription()->sendAddHintNotification();
+                this->getDescription()->sendAddHintNotification(player);
                 return true;
             }
Index: /code/trunk/src/modules/questsystem/QuestNotification.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestNotification.cc	(revision 7402)
+++ /code/trunk/src/modules/questsystem/QuestNotification.cc	(revision 7403)
@@ -29,4 +29,5 @@
 #include "QuestNotification.h"
 #include "core/CoreIncludes.h"
+#include "infos/PlayerInfo.h"
 
 namespace orxonox {
@@ -70,10 +71,12 @@
     @brief
         Send the QuestNotification.
+    @param player
+        The player the Notification is sent to.
     @return
         Returns true if successful.
     */
-    bool QuestNotification::send(void)
+    bool QuestNotification::send(PlayerInfo* player)
     {
-        return this->Notification::send(QuestNotification::SENDER);
+        return this->Notification::send(player->getClientID(), QuestNotification::SENDER);
     }
 
Index: /code/trunk/src/modules/questsystem/QuestNotification.h
===================================================================
--- /code/trunk/src/modules/questsystem/QuestNotification.h	(revision 7402)
+++ /code/trunk/src/modules/questsystem/QuestNotification.h	(revision 7403)
@@ -50,5 +50,5 @@
             virtual ~QuestNotification(); //!< Destructor.
 
-            bool send(void); //!< Send the QuestNotification.
+            bool send(PlayerInfo* player); //!< Send the QuestNotification.
 
         private:
Index: /code/trunk/src/orxonox/interfaces/NotificationListener.h
===================================================================
--- /code/trunk/src/orxonox/interfaces/NotificationListener.h	(revision 7402)
+++ /code/trunk/src/orxonox/interfaces/NotificationListener.h	(revision 7403)
@@ -49,4 +49,15 @@
     /**
     @brief
+        Struct that overloads the compare operation between two PickupIdentifier pointers.
+    */
+    //TODO: 
+    struct NotificationListenerStringCompare
+    {
+        bool operator() (const std::string& lhs, const std::string& rhs) const
+            { return lhs.compare(rhs) < 0; }
+    };
+
+    /**
+    @brief
         NotificationListener interface.
     @author
@@ -59,5 +70,5 @@
             virtual ~NotificationListener() {}
 
-            virtual const std::set<std::string> & getTargetsSet() = 0;
+            virtual const std::set<std::string, NotificationListenerStringCompare> & getTargetsSet() = 0;
             virtual void update(void) = 0;
             virtual void update(Notification* notification, const std::time_t & time) = 0;
